package jp.co.yahoo.hadoop.common;

import java.io.IOException;
import org.apache.hadoop.mapreduce.Reducer;

/**
 * Performs no reduction, writing all input values directly to the output.
 */
public class IdentityReducer<K, V> extends Reducer<K, V, K, V> {
	public void reduce(K key, Iterable<V> values, Context context)
			throws IOException, InterruptedException {
		for (V value : values) {
			context.write(key, value);
		}
	}
}