package jp.co.yahoo.hadoop.ml.common;

import java.io.IOException;

import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

/**
 * A reducer for testing classification or regression using MAE.
 */
public class TestMAEReducer extends
		Reducer<IntWritable, DoubleWritable, NullWritable, Text> {
	private double diffSum = 0;
	private int trainSize = 0;
	
	@Override
	public void reduce(IntWritable key, Iterable<DoubleWritable> values,
			Context context) throws IOException, InterruptedException {
		for (DoubleWritable value : values) {
			diffSum += value.get();
			trainSize += key.get();
		}
	}
	
	@Override
	public void cleanup(Context context) throws IOException,
			InterruptedException {
		String result = "MAE: " + (diffSum / trainSize);
		context.write(NullWritable.get(), new Text(result));
	}
}
